# 4. Update the Password

## Introduction

This PUT endpoint is the final step of the password reset process.

There are three required parameters that must be provided in the request:

1. **Et-App-Key** (header). This is the unique key of your app that identifies your app when communicating with our service. Contact your administrator to get this key.
2. **API version** (path). Unless necessary, leave it at "1.0".
3. **resource** (body). This is a JSON file that contains the the token from the previous step as well as the new password.

### Request Body

| Parameter            | Description                                                                                                                            |
| -------------------- | -------------------------------------------------------------------------------------------------------------------------------------- |
| Token                | This is the token returned in the [previous endpoint](/rest-api/trading-api/password-reset/2.-generate-a-token-for-a-new-password.md). |
| Password             | This is the new password of the trader.                                                                                                |
| PasswordConfirmation | This is the new password of the trader (must be identical to `Password`).                                                              |

```javascript
{
  "Token": "someToken-bd26-825db0",
  "Password": "pkof394f34kf934f03u4fj0",
  "PasswordConfirmation": "pkof394f34kf934f03u4fj0"
}
```

Here's the final template for this API request:

```
PUT apiURL/v1.0/users/passwords/reset/
```

## Response

In response to this API request, you will receive a JSON file either confirming successful token generation or enumerating errors that occurred in the process.

```javascript
{
  "Errors": [],
  "IsSucceed": true
}
```

At this point the password has been successfully reset, and the trader may proceed to log into Autoshares Trade using the new password.

## Common Mistakes

Here are some of the common mistakes that developers make when attempting to reset a trader's password.

### Failing to Specify the Et-App-Key Parameter

If you specify the wrong Et-App-Key parameter or fail to include it in the header altogether, you'll get the following error:

```javascript
{
    "error": "Application key is not defined or does not exist"
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://api-documentation.autoshares.dev/rest-api/trading-api/password-reset/3.-update-the-password.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
